import { Component, h } from "preact";
import { Router, route } from "preact-router";
import Header from "./header";
import Menu from "./menu";
import { useCallback, useReducer, useState } from "preact/hooks";
import { AppData, AppDataProvider } from '../utils';
import { Home, Users, Profile, Login, Logout } from "../route";
import { AppStateProvider } from "../store/AppState";
class App extends Component {
  // useReducer
  appdata = AppData();
  session = this.appdata.get("Session");
  menutoggle = this.appdata.get("menutoggle");
  toggleMenu = () => {

    const [visible, setValue] = useState(false);
    const toggle = useCallback(() => {
      setValue(!visible);
      return !visible;
    }, [visible]);
    return { visible, toggle };
  }
  componentWillUnmount() {
    //this.sub();
  }
  menu_items = [
    { text: "Übersicht", path: "/" },
    { text: "Benutzer", path: "/users" },
    { text: "System", path: "/system" },
    { text: "Profil", path: "/profile" },
    { text: "Abmelden", path: "/logout" }
  ]
  handleRoute = async e => {
    const isAuthed = this.session.actions.isAuth();
    switch (e.url) {
      default:
        if (!isAuthed) route('/login', true);
        break;
    }
  };
  render() {
    let menu = this.toggleMenu();
    const [menu_shown, toggle_menu] = useReducer(menuReducer,false);
    this.menutoggle.data = menu;
    let session = this.session;
    session.addAction("isAuth", () => { return session.data && session.data.username !== '' })
    console.log(session.actions);
    session.sub(this);
    return (

      <AppDataProvider>
        <AppStateProvider value={{menu_shown, toggle_menu}} >
        <div id="wrapper">
          <Header menu={menu} />
          <div class="page">
            <Menu menu={menu} items={this.menu_items} />
            {!menu.visible &&

              <Router onChange={this.handleRoute}>
                <Home path="/" user="me" />
                <Login path="login" />
                <Profile path="/profile/:user" />
                <Logout path="/logout" />
                <Users path="/users" />
                <div class="container" default>Error 404</div>
              </Router>

            }
          </div>
          <footer>
            <div className="container" style={'text-align: center; align-items: center'}>
              <span>&copy; Jean Jacques Avril 2022 </span>
              </div>
            
          </footer>
        </div>
        </AppStateProvider>
      </AppDataProvider>
    );
  }



}

export default App;
