

function subscribe (c) {

    this.observers.push(c);
    return () => { this.observers.splice(this.observers.indexOf(c), 1) }
}
function getStore(path){
    let path_slices = path.split("/");
    let current=this;
    for(let s of path_slices){
        if(!(s in current.tree))
            current.tree[s] = new ObservableData();
        current = current.tree[s];
    }
    return current;
}
function addAction(name, f){
    this._actions[name] = f.bind(this._data);
}
function ObservableData() {
    this.observers = [];
    this.tree = {};
    this._data = {};
    this._actions = {};
    const dispatchChange = () => {
        this.observers.map(c=>c.forceUpdate());
    }
    return {
        tree:this.tree,
        addAction: addAction.bind(this),
        sub: subscribe.bind(this),
        get: getStore.bind(this),
        get data() {
            return this._data;
        },
        set data(val) {
            this._data = val;
            dispatchChange();
        },
        actions: this._actions,
        
    }
}
export default ObservableData;